#include <stdio.h>
#include <math.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/dir.h>
#include <sys/param.h>

char appdirname[1024];
char outdirname[1024];
char cddirname[1024];
char ripfilename[1024];
char trackfilename[1024];
char ripline[1024];
char reply[256];
char command[1024];

char drive[64];

long ok,line,istop,i,count,tn,numberoftracks;

long wavstarts[99];
long nstarts, newstart;

long mins[99],startframe[99];
double secs[99];

char yesno[5];

FILE* ripfile;
FILE* tracklistfile;

void read_settings_file(void);
long get_command(void);
void parse_trackinfo(void);
void make_timefiles(void);

int main(int argc,char* argv[])
{
  
  
  printf("  ClassicRip Ver 0.50  5th December 2014\n");
  printf("  ======================================\n\n");
  printf("Lets the user list how to rip an Audio CD\n");
  
  sprintf(appdirname,"%s",argv[0]);
  ok=(long)strrchr(appdirname,'/')-(long)appdirname;
  appdirname[ok]=(char)0;
  printf("Application directory = %s\n",appdirname);
  
  sprintf(ripfilename,"%s/riplines",appdirname);
  printf("Ripping commands stored in\n  => %s\n",ripfilename);
  
  read_settings_file();
  printf("Output to directory: %s\n",outdirname);
  
  line=0;
  
  printf("Enter sub-directory name for this CD's output/n  => ");
  scanf("%s",reply);
  sprintf(cddirname,"%s/%s",outdirname,reply);
  printf("OK, this CD's files into %s\n",cddirname);
  
  ripfile=fopen(ripfilename,"wt");
  
  
  
  sprintf(command,"mkdir %s",cddirname);
  fprintf(ripfile,"%s\n",command);
  sprintf(command,"cdparanoia -d %s -Q 2> %s/tracks.txt",drive,cddirname);
  fprintf(ripfile,"%s\n",command);
  i=0;
  do
  {
    wavstarts[i]=0;
    i++;
  } while (i<99);
  
  count=2; nstarts=0;
  istop=0;
  do
  {
    printf("Enter track spec => ");
    scanf("%s",reply);
    
    if (reply[0]=='0') istop=1;
    if (reply[0]=='q') istop=1;
    if (reply[0]=='Q') istop=1;
    
    if (istop==0)
    {
      sprintf(command,"cdparanoia -d %s -z %s %s/%stracks.wav",drive,reply,cddirname,reply);
      
      sscanf(reply,"%ld",&newstart);
      
      fprintf(ripfile,"%s\n",command);
      printf("%s\n",command);
      
      wavstarts[newstart]=1;
      nstarts++;
      printf("start section %ld from track %ld \n",nstarts,newstart);
      
      count++;
    }
    
   } while (istop==0);
   
   fclose(ripfile);
   
   printf("The list of commands is:\n\n");
   ripfile=fopen(ripfilename,"rt");
   i=0;
   do
   {
     istop=get_command();
     printf("%s\n",command);
     
     i++;
   } while (i<count);
   
   fclose(ripfile);
   
   printf("\n\n Press 'y' or 'Y' to execute - or any other key to stop.");
   printf("\n\n  => ");
   
   scanf("%s",yesno);
   if (yesno[0]=='y')
   { 
      yesno[0]='Y';
   }
   
   if (yesno[0]=='Y')
   {
     
     
     ripfile=fopen(ripfilename,"rt");
     i=0;
     do
     {
       istop=get_command();
       printf("%s\n",command);
       system(command);
       i++;
     } while (i<2);
     
     printf("Output directory created and track details read\n");
     
     parse_trackinfo();
     make_timefiles();
     /* more of the loop here when parsing OK */
     
     printf("Commence ripping\n");
     
     do
     {
       istop=get_command();
       printf("%s\n",command);
       system(command);
       i++;
     } while (i<count);
   
     fclose(ripfile);
     

   }
   else
   {
     printf("Commands abandoned!\n");
   }
   
  
  
  printf(" * Done ! *\n");
}

void make_timefiles(void)
{
  long atfile, framediff, frameatstart;
  long minsnow,secsnow;
  
  FILE* tfile;
  
  char timefilename[1024];
  
  sprintf(timefilename,"%s/Notes.txt",cddirname);
  
  printf("Time file name = %s\n",timefilename);
  
  tfile=fopen(timefilename,"wt");
  
  printf("Create time listing files\n");
  
  printf("Number of files = %ld\n",nstarts);
  
  atfile=1;
  do
  {
    if(wavstarts[atfile]==1)
    {
      frameatstart=startframe[atfile];
      printf("File starts with track %ld frame %ld\n",atfile,frameatstart);
      
      
      fprintf(tfile,"\n\n  %ld\n  ======\n",atfile);
      fprintf(tfile,"  00:00\n");
      
    }
    else
    {
      framediff=startframe[atfile]-frameatstart;
      secsnow=framediff/75;
      minsnow=secsnow/60;
      secsnow=secsnow-(60*minsnow);
      printf("  frame diff %ld => %02ld %02ld\n",framediff,minsnow,secsnow);
      
      fprintf(tfile,"  %02ld:%02ld\n",minsnow,secsnow);
      
    }
    
    atfile++;
  } while (atfile<=numberoftracks);
  
  fclose(tfile);
}

void parse_trackinfo(void)
{
  long mp,fp,dum,tlc;
  int lok;
  char trackline[256];
  float fdum,sp;
  char tfchar;
  printf("Parsing track details\n\n\n");
  
  sprintf(trackfilename,"%s/tracks.txt",cddirname);
  printf("%s\n",trackfilename);
  
  tracklistfile=fopen(trackfilename,"rt");
  
  printf("File header\n\n");
  
  do
  {
    fscanf(tracklistfile,"%c",&tfchar);
    printf("%c",tfchar);
  } while (tfchar!='=');
  
  do
  {
    fscanf(tracklistfile,"%c",&tfchar);
    printf("%c",tfchar);
  } while (tfchar=='=');
  
  printf("Now track data to parse\n\n");
  
  /* fscanf(tracklistfile,"%c",&tfchar); */
  
    /* read a line */
    
  tn=0; lok=1;
  do
  {
    
  tlc=0;
  do
  {
    fscanf(tracklistfile,"%c",&tfchar);  
    if( 14 < (int)tfchar)
    {
      trackline[tlc]=tfchar;
      tlc++;
    }
    else
    {
      trackline[tlc]=(char)0;
      tlc=(-99);
    }
    if(tlc>80)
    {
      tlc=(-99);
    }
  } while (tlc>0);
  printf(" %s\n",trackline);
  
  /* parse values */
  
  if (trackline[0]==(char)' ')
  {
    tn++;
  
  sscanf(trackline," %ld. %ld [%ld:%f] %ld [%ld:%f",&dum,&dum,&dum,&fdum,&fp,&mp,&sp);
  
  startframe[tn]=fp; mins[tn]=mp; secs[tn]=(double)sp;
  
  /* printf("starts at %ld frame %ld mins %6.2lf secs\n",startframe[tn],mins[tn],secs[tn]); */
  
  }
  else
  {
    lok=0;
    
    sscanf(trackline,"TOTAL %ld [%ld:%f",&fp,&mp,&sp);
    startframe[0]=fp; mins[0]=mp; secs[0]=(double)sp;
    
    startframe[tn+1]=fp; mins[tn+1]=mp; secs[tn+1]=(double)sp;
    
    printf("Track list parsed\n");
  }
  
  
  } while (lok==1);
  
  numberoftracks=tn;
  
  
  fclose(tracklistfile);
  
  printf("%ld tracks found on CD\n",numberoftracks);
  tn=1;
  do
  {
    printf("Track %ld starts at %7ld frame %02ld mins %6.2lf secs\n",tn,startframe[tn],mins[tn],secs[tn]);
    tn++;
  } while (tn<=numberoftracks);
  
  printf("Disc end at %7ld frame %02ld mins %6.2lf secs\n",startframe[0],mins[0],secs[0]);
}

long get_command(void)
{
  long check,ic;
  char ch;
  check=0;
  ic=0;
  do
  {
    fscanf(ripfile,"%c",&ch);
    
    if(15<(long)ch)
    {
      command[ic]=ch;
      ic++;
    }
    else
    {
      check=1;
      command[ic]=(char)0;
    }
  } while (check==0);
}

void read_settings_file(void)
{
  
  /* This proceedure reads the 'settings' file. */
  
  FILE *setfile; 
  unsigned char setfilename[512];
  sprintf(setfilename,"%s/Settings",appdirname);
  printf("Reading settings from %s\n\n",setfilename);
  setfile=fopen(setfilename,"rt");  
  
  fscanf(setfile,"%s",outdirname);
  fscanf(setfile,"%s",drive);
  
  fclose(setfile);
}

